SystemOrganization addCategory: #'Seaside-Tests-Playground'!

WAComponent subclass: #WAPlaygroundComponent
	instanceVariableNames: 'code callbackValues simpleTag formTag tableTag jqueryTag currentPosition history saved'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Playground'!

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
description
	^ 'Seaside playground'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 13:04'!
exampleCode
^'html big: ''TEST Playground''.
html form: [
 html multiSelect list: #(11 12 13 14 15);
   selected: (values at: #list ifAbsent: []);
   callback: [:v | values at: #list put: v ].
 html break.
 html textInput value: (values at: #input ifAbsent: []);  callback: [:v | values at: #input put: v].
 html break.
html submitButton value: ''OK'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/2/2010 20:39'!
exampleJQCode
^'html anchor
 onClick: ((html jQuery: #itsme) fadeIn: 1 seconds);
 with: ''Show''.
html space: 2.
html anchor
 onClick: ((html jQuery: #itsme) hide: 1 seconds);
 with: ''Hide''.
html div id: ''itsme'';
 style: ''border:1px solid #ccc;width:100px;background:#fee'';
 with: [
  html div: ''I am DIV''.
  html div: ''with some text....'']'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:14'!
formTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #list put: self listTemplate.
	dict at: #multiList put: self multiListTemplate.
	dict at: #form put: self formTemplate.
	dict at: #inputField put: self textInputTemplate.
	dict at: #textField put: self textAreaTemplate.
	dict at: #submitButton put: self submitButtonTemplate.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 17:11'!
formTemplate
	^'html form: [].'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:06'!
fullTableTemplate
	^'html table: [
   html tableRow: [
     html tableHeading: ''Header 1''.
     html tableHeading: ''Header 2''].
   html tableRow: [
     html tableData: ''Data 1''.
     html tableData: ''Data 2''].
   ].'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 18:16'!
handlerName
	^'examples/playground'! !

!WAPlaygroundComponent class methodsFor: 'class initialization' stamp: 'obi 1/2/2010 19:49'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: self handlerName.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:16'!
listTemplate
	^'html select list: #(1 2 3 4 5);
   selected: (values at: #list1 ifAbsent: []);
   callback: [:v | values at: #list1 put: v].'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:16'!
multiListTemplate
	^'html multiSelect list: #(11 12 13 14 15);
   size: 4;
   selected: (values at: #multiList1 ifAbsent: []);
   callback: [:v | values at: #multiList1 put: v].'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:47'!
simpleTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #break put: 'html break.'.
	dict at: #div put: 'html div: [].'.
	dict at: #text put: 'html text: ''a text''.'.
	dict at: #span put: 'html span: [].'.
	dict at: #hr put: 'html horizontalRule.'.
	dict at: #heading put: 'html heading level2; with: ''Title''.'.
	dict at: #big put: 'html big: ''BIG''.'.
	dict at: #space put: 'html space.'.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 17:27'!
submitButtonTemplate
	^'html submitButton callback: []; value: ''OK'''! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:14'!
tableTagTemplates
	| dict |
	dict := Dictionary new.
	dict at: #table put: 'html table: [].'.
	dict at: #tableData put: 'html tableData: [].'.
	dict at: #tableHeading put: 'html tableHeading: [].'.
	dict at: #tableRow put: 'html tableData: [].'.
	dict at: #fullTable put: self fullTableTemplate.
	^dict! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:18'!
textAreaTemplate
	^'html textArea
   rows: 5;
   columns: 60;
   callback: [:value | values at: #text1 put: value];
   value: (values at: #text1 ifAbsent: ['''']).'! !

!WAPlaygroundComponent class methodsFor: 'accessing' stamp: 'obi 1/3/2010 21:17'!
textInputTemplate
	^'html textInput
   callback: [:value | values at: #input1 put: value];
   value: (values at: #input1 ifAbsent: ['''']).'! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 20:57'!
addTagScriptOn: script type: aSymbol
	| code1 code2 codePart |
	codePart := self templateAt: aSymbol.
	codePart isNil ifTrue: [^self].
	script add: (script jQuery id: 'codeDiv') effect.
	currentPosition < code size
		ifTrue: [	code1 := code copyFrom: 1 to: currentPosition.
				code2 := code copyFrom: currentPosition + 1 to: code size.
				code := code1,'
  ' , codePart , code2 ]
		ifFalse: [
			code isEmpty 
				ifTrue: [code := ' ', codePart]
				ifFalse: [code := code, '
  ',codePart ] ].
	self perform: (aSymbol ,':') asSymbol with: nil.
	script add: ((script jQuery id: 'codeDiv') html: [:r | self htmlCodeOn: r]).
	script add: ((script jQuery id: 'lists') html: [:r | self renderListsOn: r]).
	script add: ((script jQuery id: 'output') html: [:r | self evaluateWith: r]).
	self addToHistory! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:36'!
addToHistory
	history isEmpty ifFalse: [history last = code ifTrue: [ ^self ] ].
	history add: code! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 13:05'!
buildCode
	^'[:html :values | ', code ,']'! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/2/2010 18:51'!
callbackValuesString
	| stream |
	stream := WriteStream on: String new.
	callbackValues keysAndValuesDo: [:k :v |
		stream nextPutAll: k asString, ' -> ', v printString.
		stream cr.].
	^stream contents! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:12'!
clearCallbackValues
	callbackValues := Dictionary new! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code
	^code! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/2/2010 18:22'!
code: aString
	code := aString! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 13:03'!
evaluateWith: html
	
	[(Compiler evaluate: self buildCode) value: html value: callbackValues ] on: Error do: [:ex | html div class: 'error'; with: ex. ex resume]! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
formTag
	^ formTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
formTag: anObject
	formTag := anObject! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:50'!
formTagList
	^self class formTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/3/2010 20:38'!
historyBack
	history size > 1
		ifTrue: [
			history removeLast.
			code := history last ].
! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 16:29'!
htmlCodeOn: html
	html div id: 'codeDiv';
		with: [
			 html textArea id: 'code'; columns: 100; rows: 20; on: #code of: self ]! !

!WAPlaygroundComponent methodsFor: 'initialization' stamp: 'obi 1/3/2010 20:26'!
initialize
	super initialize.
	code := ''.
	callbackValues := Dictionary new.
	saved := Dictionary new.
	history := OrderedCollection new.! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
jqueryTag
	^ jqueryTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
jqueryTag: anObject
	jqueryTag := anObject! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:21'!
loadExample
	code := self class exampleCode! !

!WAPlaygroundComponent methodsFor: 'actions' stamp: 'obi 1/2/2010 19:52'!
loadJQExample
	code := self class exampleJQCode! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 20:55'!
onChangeScriptOn: html type: aSymbol
	^html jQuery ajax
		serializeForm;
		serializeForm: (html jQuery: #formCode);
								callback: [ :value | currentPosition := value asNumber ] value: ((html jQuery: #code) attributeAt: 'selectionStart') ;
								script: [:s | self addTagScriptOn: s type: aSymbol]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 20:39'!
renderContentOn: html
	html heading level3; with: 'Seaside playground'.
	html div id: 'output'; 
		with: [ self evaluateWith: html ].
	html form: [
			html table: [
				html
					tableHeading style: 'width:820px';
						with: [
							html div id: 'lists';
								with: [self renderListsOn: html ] ].
				html tableHeading: 'Values' ] ].
	html form id: 'formCode';
		with: [
		html table: [
			html tableRow: [
				html tableData: [ self htmlCodeOn: html].
				html tableData: [ html textArea columns: 40; rows: 20; value: self callbackValuesString] ] ].
		html submitButton value: 'Save'; callback: [self addToHistory].
		html space.
		html submitButton value: 'Reset'; callback: [self clearCallbackValues].
		html space.
		html button value: 'Undo'; callback: [self historyBack].
		html space.
		html submitButton value: 'Clear'; callback: [code := ''. self clearCallbackValues].
		html space.
		html submitButton value: 'Example'; callback: [self loadExample ].
		html space.
		html submitButton value: 'JQ Example'; callback: [self loadJQExample ] ]! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 21:11'!
renderListsOn: html
	html select
		onChange: (self onChangeScriptOn: html type: #simpleTag);
		list: self tagList;
		beOptional;
		optionalLabel: '- Simple tags - ';
		callback: [:value | simpleTag := value. ].
	html space.
	html select
		onChange: (self onChangeScriptOn: html type: #formTag);
		list: self formTagList;
		beOptional;
		optionalLabel: '- Form tags - ';
		callback: [:value | formTag := value. ].
	html space.
	html select
		onChange: (self onChangeScriptOn: html type: #tableTag);
		list: self tableTagList;
		beOptional;
		optionalLabel: '- Table tags - ';
		callback: [:value | tableTag := value. ].! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
simpleTag
	^ simpleTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:14'!
simpleTag: anObject
	^ simpleTag := anObject! !

!WAPlaygroundComponent methodsFor: 'rendering' stamp: 'obi 1/3/2010 20:27'!
style
	^'h3, th  {
color:#FF7200;
font-size:20px;
margin-bottom:6px;}
th {text-align:left}
.error {color:red;font-size:14px;font-family:verdana}
 #output {background:#fff;height:400px;overflow:auto;border:1px solid #ccc;padding:4px;margin:4px}'! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
tableTag
	^ tableTag! !

!WAPlaygroundComponent methodsFor: 'accessing' stamp: 'obi 1/3/2010 20:15'!
tableTag: anObject
	tableTag := anObject! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 21:07'!
tableTagList
	^self class tableTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:42'!
tagList
	^self class simpleTagTemplates keys asSortedCollection! !

!WAPlaygroundComponent methodsFor: 'private' stamp: 'obi 1/3/2010 20:58'!
templateAt: aSymbol
	^(self class perform: (aSymbol, 'Templates') asSymbol) at: (self perform: aSymbol) ifAbsent: []! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:39'!
theme
	^JQBaseTheme default! !

!WAPlaygroundComponent methodsFor: 'updating' stamp: 'obi 1/2/2010 19:38'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	self theme updateRoot: anHtmlRoot.
	JQUiAllTestsLibrary default 
		updateRoot: anHtmlRoot! !
WAPlaygroundComponent initialize!
